// ===========================================
//  Interface part of NPAPI.DCU with comments
//
// (C) Copyright 1997-1998 Andrei N. Kashin
// E-mail: Andrei.Kashin@Fysik.uu.se
//
//   Do not remove this CopyRight.
// ===========================================

unit npapi;

interface

uses Classes,Forms,Controls,Windows,Messages;


{    An implementation of npapi.h in Pascal is below.
     You can freely use this part to implement your own
     Netscape Plugin API based applications    }

const NP_VERSION_MAJOR = 0;
      NP_VERSION_MINOR = 6;

type uint16 = word;
     uint32 = cardinal;
      int16 = SmallInt;
      int32 = integer;

     TNPBool  = Boolean;
     TNPEvent = pointer;
     TNPError = int16;
     TNPMIMEType = PChar;

{ NPP is a plug-in's opaque instance handle}
TNPP = packed record
    pdata:pointer;   {plug-in private data}
    ndata:pointer; {netscape private data}
  end;
PNPP = ^TNPP;

TNPStream = packed record
     pdata:pointer;   {plug-in private data}
     ndata:pointer; {netscape private data}
     url:PChar;
    _end:uint32;
     lastmodified:uint32;
end;
PNPStream = ^TNPStream;

PNPByteRange = ^TNPByteRange;
TNPByteRange = packed record
  offset:int32;    {negative offset means from the end}
  length:uint32;
  next:PNPByteRange;
end;

TNPSavedData = packed record
    len:uint32;
    buf:pointer;
end;
PNPSavedData = ^TNPSavedData;

TNPRect = packed record
    top: uint16;
   left: uint16;
 bottom: uint16;
  right: uint16;
end;

PNPWindow = ^TNPWindow;
TNPWindow = packed record
  window: pointer; {platform specific window handle}
       x: uint32;  {position of top left corner relative to a netscape page}
       y: uint32;
   width: uint32;  {maximum window size}
  height: uint32;
clipRect: TNPRect; {clipping rectangle in port coordinates}
end;

TNPFullPrint = packed record
 pluginPrinted:TNPBool; {set TRUE if plugin handled fullscreen printing}
 printOne:TNPBool; {TRUE if plugin should print one copy to default printer}
 platformPrint:pointer; {Platform-specific printing info}
end;

TNPEmbedPrint = packed record
 window:TNPWindow;
 platformPrint:pointer; {Platform-specific printing info}
end;

PNPPrint = ^TNPPrint;
TNPPrint = packed record
  mode:uint16; {NP_FULL or NP_EMBED}
  case uint16 of
   2:(fullPrint:TNPFullPrint;);   {if mode is NP_FULL}
   1:(embedPrint:TNPEmbedPrint); {if mode is NP_EMBED}
end;

const NP_EMBED = 1;
      NP_FULL  = 2;
      NP_BACKGROUND = 3;
      NP_NORMAL = 1;
      NP_SEEK   = 2;
      NP_ASFILE = 3;


{** Error and reason code definitions **}
NP_NOERR = 0;
NP_EINVAL = 1;
NP_EABORT = 2;

NPERR_BASE                     = 0;
NPERR_NO_ERROR                 = NPERR_BASE + 0;
NPERR_GENERIC_ERROR            = NPERR_BASE + 1;
NPERR_INVALID_INSTANCE_ERROR   = NPERR_BASE + 2;
NPERR_INVALID_FUNCTABLE_ERROR  = NPERR_BASE + 3;
NPERR_MODULE_LOAD_FAILED_ERROR = NPERR_BASE + 4;
NPERR_OUT_OF_MEMORY_ERROR      = NPERR_BASE + 5;
NPERR_INVALID_PLUGIN_ERROR     = NPERR_BASE + 6;
NPERR_INVALID_PLUGIN_DIR_ERROR = NPERR_BASE + 7;
NPERR_INCOMPATIBLE_VERSION_ERROR =NPERR_BASE + 8;

NPRES_BASE        = 0;
NPRES_DONE        = NPRES_BASE + 0;
NPRES_NETWORK_ERR = NPRES_BASE + 1;
NPRES_USER_BREAK  = NPRES_BASE + 2;


{***  Function prototypes
  Functions beginning with 'NPP' are functions provided by the plugin
    that Netscape will call.
  Functions beginning with 'NPN' are functions provided by Netscape
    that the plugin will call. }

type

TArrayPChar = array [0..100] of PChar;
PArrayPChar = ^TArrayPChar;

TNPP_Initialize = function:TNPError;
TNPP_Shutdown = procedure;
TNPP_New = function(pluginType:TNPMIMEType; instance:PNPP; mode:uint16;
             argc:int16; argn,argv:PArrayPChar; saved:PNPSavedData):TNPError; cdecl;
TNPP_Destroy = function (instance:PNPP; var save:PNPSavedData):TNPError; cdecl;
TNPP_SetWindow = function (instance:PNPP; window:PNPWindow):TNPError; cdecl;
TNPP_NewStream = function (instance:PNPP; mtype:TNPMIMEType; stream:PNPStream;
                       seekable:TNPBool; var stype:uint16):TNPError; cdecl;
TNPP_DestroyStream = function (instance:PNPP; stream:PNPStream;
                       reason:TNPError):TNPError; cdecl;
TNPP_WriteReady = function (instance:PNPP; stream:PNPStream):int32;cdecl;
TNPP_Write = function (instance:PNPP; stream:PNPStream; offset,len:int32;
                       var buf):int32;cdecl;
TNPP_StreamAsFile = procedure (instance:PNPP; stream:PNPstream;
                       const fname:PChar); cdecl;
TNPP_Print = procedure (instance:PNPP; platformPrint:PNPPrint);cdecl;
TNPP_HandleEvent = function (instance:PNPP; event:pointer):int16;cdecl;


TNPN_GetURL = function (instance:PNPP; const url,window:PChar):TNPError;cdecl;
TNPN_PostURL = function (instance:PNPP; const url,window:PChar; len:uint32;
                       buf:PChar; AsFile:TNPBool):TNPError; cdecl;
TNPN_RequestRead = function (stream:PNPStream; rangeList:PNPByteRange)
                    :TNPError; cdecl;
TNPN_NewStream = function (instance:PNPP; mtype:TNPMIMEType; stream:PNPStream)
                    :TNPError; cdecl;
TNPN_Write = function (instance:PNPP; stream:PNPStream; len:int32;
                     var buffer):int32; cdecl;
TNPN_DestroyStream = function (instance:PNPP; stream:PNPStream;
                     reason:TNPError):TNPError; cdecl;
TNPN_Status = procedure (instance:PNPP; const Msg:PChar);cdecl;
TNPN_UserAgent = function (instance:PNPP):PChar; cdecl;
TNPN_MemAlloc = function (size:uint32):pointer; cdecl;
TNPN_MemFree = procedure (ptr:pointer); cdecl;
TNPN_MemFlush = function (size:uint32):uint32; cdecl;
TNPN_ReloadPlugins = procedure (reloadPages:TNPBool); cdecl;

PNPPluginFuncs = ^TNPPluginFuncs;
TNPPluginFuncs = packed record
 size:   uint16;
 version:uint16;
 newp         : TNPP_New;
 destroy      : TNPP_Destroy;
 setwindow    : TNPP_SetWindow;
 newstream    : TNPP_NewStream;
 destroystream: TNPP_DestroyStream;
 asfile       : TNPP_StreamAsFile;
 writeready   : TNPP_WriteReady;
 write        : TNPP_Write;
 print        : TNPP_Print;
 event        : TNPP_HandleEvent;
end;

PNPNetscapeFuncs = ^TNPNetscapeFuncs;
TNPNetscapeFuncs = packed record
 size:   uint16;
 version:uint16;
 geturl       : TNPN_GetURL;
 posturl      : TNPN_PostURL;
 requestread  : TNPN_RequestRead;
 newstream    : TNPN_NewStream;
 write        : TNPN_Write;
 destroystream: TNPN_DestroyStream;
 status       : TNPN_Status;
 uagent       : TNPN_UserAgent;
 memalloc     : TNPN_MemAlloc;
 memfree      : TNPN_MemFree;
 memflush     : TNPN_MemFlush;
 reloadplugins:	TNPN_ReloadPlugins;
end;

function NP_GetEntryPoints(pFuncs:PNPPluginFuncs):TNPError; export; stdcall;
function NP_Initialize(pFuncs:PNPNetscapeFuncs):TNPError;export; stdcall;
function NP_Shutdown:TNPError;export; stdcall;


{ declaration of several Nescape Navigator functions you can use}

procedure NPN_Version(var plugin_major, plugin_minor,
                          netscape_major, netscape_minor: integer);
{ get version values of Nescape and plugin accordingly}

procedure NPN_Status(instance:PNPP; const Msg:PChar);
{ use to write something on Netscape's status bar}

function NPN_GetURL(instance:PNPP; const url,window:PChar):TNPError;
{* causes the specified URL to be fetched and streamed in *}

function NPN_PostURL(instance:PNPP; const url,window:PChar; len:uint32;
                      const buf:PChar; AsFile:TNPBool):TNPError;
{it's used to write data into specifaied URL or/and Netscape window;
 you can easily generate HTML text and show it at the Netscape window;
 see plugin documentation from Netscape corporation for full description}

function NPN_UserAgent(instance:PNPP):PChar;
{* returns the user agent string of Navigator, which contains version info }

function NPN_NewStream(instance:PNPP; mtype:TNPMIMEType; stream:PNPStream)
                      :TNPError;
{* Creates a new stream of data from the plug-in to be interpreted
   by Netscape in the current window.*}

function NPN_Write(instance:PNPP; stream:PNPStream;
                   len:int32; var buffer):int32;
{* Provides len bytes of data.*}


{ Tool specific  declarations}

function NPN_GetArgValue(Instance:PNPP; ArgName:PChar):PChar;
{ utility function to get values of parameters from EMBED tag easily.
  You can define your own parameters to initalize your form acording
  with them.
  The ArgName is not case sensitive.
  If parameter with name ArgName doesn't exist function will
  return empty string ( '' ).
  See MForm.pas and Test.htm for an example how to use the function. }



{====== TNetscapeStream declaration ====== }

const NM_NewStream     = wm_user + 319;
{message sent to the form when a new Netscape stream is to be created}

type

TAsFileNotify = procedure (Sender:TObject; FileName:PChar) of object;
TReadNotify = procedure (Sender:TObject; Buf:pointer; ByteCount:integer) of object;
TCloseNotify = procedure (Sender:TObject; Reason:TNPError) of object;

TNPStreamState = (nsClosed,nsRead,nsWaitingAsFile);
TNPStreamType = (stNormal,stAsFile);

TNetscapeStream = class(TComponent)
     private
       FOnAsFile:TAsFileNotify;
       FOnClose:TCloseNotify;
       FOnRead:TReadNotify;
       Stream:PNPStream;
       FInstance:PNPP;
       FType:TNPStreamType;
       FState:TNPStreamState;
       function GetURL:PChar;
       procedure SetType(SType:TNPStreamType);
      public
       property URL:Pchar read GetURL;
       property State:TNPStreamState read FState;
       constructor Create(AOwner:TComponent);override;
       destructor Destroy; override;
       procedure Accept(StreamA:PNPStream; InstanceID:PNPP);
       procedure CloseStream;
      protected
       procedure AsFileHandler(FileName:PChar);
       procedure DestroyHandler(Reason:TNPError);
       procedure ReadHandler(var Buf; ByteCount:integer);
      published
       property OnAsFile:TAsFileNotify read FOnAsFile write FOnAsFile;
       property OnCloseStream:TCloseNotify read FOnClose write FOnClose;
       property OnRead:TReadNotify read FOnRead write FOnRead;
       property StreamType:TNPStreamType read FType write SetType
                default stNormal;
     end;

{ This is a non visual component to simplify the using of Netscape's streams.
 To get data from URL stated in SRC parameter of EMBED tag you have to use this
 component. It is bilt into NPAPI.DCU and support a limited subset of Netscape's
 streams functions to read data from URL.

It supports two types of Netscape streams:

1) stNORMAL

   You'll get notifications onRead to read portions of data as they ready,
   their memory location and size.
   In case of successful transfer completion you'll get notification event
  onCloseStream with Reason code NPRES_DONE; in case of user pressed Stop
  button or network error you'll get Reason code NPRES_USER_BREAK and
  NPRES_NETWORK_ERR accordingly.

2) stAsFile

  You'll get notification onAsFile when a local copy of URL will be created or
  notification onCloseStream with corresponding reason code in case of failure.

You can use read only property URL to know out the URL from which you are
receiving data.

The special message NM_NewStream will be sent to a form when a new stream is to
be created. You can ignore this message or use Accept procedure to handle the
stream by TNetscapeStream object. The address of Netscape stream structure is
passed trough LParam of the message.

You can close stream in any time by calling CloseStream procedure
(the reason for that may be invalid data you get, for example.}

TPluginForm = class(TForm)
  private
   FInstanceID:PNPP;
  protected
   procedure CreateWindowHandle(const Params: TCreateParams); override;
   constructor NPCreate(Instance:PNPP; Wnd:HWnd);
  public
   destructor Destroy; override;
   property InstanceID:PNPP read FInstanceID;
end;

TPluginFormClass = class of TPluginForm;

procedure RegisterPluginForm(FormClass:TPluginFormClass);
{procedure to register your form to be created as an embedded object.
 It's more preferable to call this function in the initialization
 part of the form implementation unit}


implementation

uses SysUtils;

type
 PHWND = ^HWND;

 PPluginInstance = ^TPluginInstance;
 TPluginInstance = record
   window:HWND;
   MControl:TForm;
   lpfnOld:pointer;
   fwindow:PNPWindow;
   fmode:uint16;
   ParamCnt:integer;
   ParamBuf:PChar;
 end;

const g_pNavigatorFuncs:PNPNetscapeFuncs = nil;
      PluginFormClass:TPluginFormClass=nil;

procedure RegisterPluginForm(FormClass:TPluginFormClass);
begin
  PluginFormClass:=FormClass;
end;

procedure TPluginForm.CreateWindowHandle(const Params: TCreateParams);
var P:TCreateParams;
begin
  P:=Params;
  P.Style:=ws_child or ws_border;
  inherited CreateWindowHandle(P);
end;

constructor TPluginForm.NPCreate(Instance:PNPP; Wnd:HWnd);
begin
 FInstanceID:=Instance;
 CreateParented(Wnd);
end;

destructor TPluginForm.Destroy;
begin
 if FInstanceID<>nil then begin
  TPluginInstance(FInstanceID^.pdata^).MControl:=nil;
  FInstanceID:=nil;
 end;
 inherited Destroy;
end;

{=======  TNetscapeStream ===================}

constructor TNetscapeStream.Create(AOwner:TComponent);
begin
 inherited Create(AOwner);
 FState:=nsClosed;
end;

procedure TNetscapeStream.Accept(StreamA:PNPStream; InstanceID:PNPP);
begin
 Stream:=StreamA;
 FInstance:=InstanceID;
 StreamA^.pdata:=self;
 if StreamType=stNormal then FState:=nsRead
                        else FState:=nsWaitingAsFile;
end;

function NPN_DestroyStream(instance:PNPP; stream:PNPStream; reason:TNPError)
                          :TNPError;forward;

procedure TNetscapeStream.CloseStream;
begin
 if State<>nsClosed then begin
   if Assigned(FOnClose) then FOnClose(Self,NP_EAbort);
   NPN_DestroyStream(FInstance,Stream,NP_EAbort);
   Stream^.pdata:=nil;
   Stream:=nil;
   FInstance:=nil;
   FState:=nsClosed;
 end;
end;

destructor TNetscapeStream.Destroy;
begin
 CloseStream;
 inherited Destroy;
end;

function TNetscapeStream.GetURL:PChar;
begin
 if Stream<>nil then Result:=Stream^.url
 else Result:='';
end;

procedure TNetscapeStream.AsFileHandler(FileName:PChar);
begin
 if Assigned(FOnAsFile) then FOnAsFile(Self,FileName)
end;

procedure TNetscapeStream.DestroyHandler(Reason:TNPError);
begin
 if State<>nsClosed then begin
   if Assigned(FOnClose) then
   if not((StreamType=stAsFile) and (Reason=NPRES_DONE)) then
   FOnClose(Self,Reason);
   Stream^.pdata:=nil;
   Stream:=nil;
   FInstance:=nil;
   FState:=nsClosed;
  end;
end;

procedure TNetscapeStream.ReadHandler(var Buf; ByteCount:integer);
begin
 if (State=nsRead) and Assigned(FOnRead) then
 FOnRead(Self,@Buf,ByteCount);
end;

procedure TNetscapeStream.SetType(SType:TNPStreamType);
begin
 if State=nsClosed then FType:=SType;
end;

procedure Register;
begin
  RegisterComponents('System', [TNetscapeStream]);
end;


{===========     Netscape functions ==========}


function NPP_InitializeDef:TNPError; forward;
procedure NPP_ShutdownDef; forward;

const NPP_Initialize:TNPP_Initialize = NPP_InitializeDef;
      NPP_Shutdown:TNPP_Shutdown = NPP_ShutdownDef;


{* called immediately after the plugin DLL is loaded
*}
function NP_Initialize(pFuncs:PNPNetscapeFuncs):TNPError;
begin
    {* trap a NULL ptr *}
    if pFuncs = nil then begin
        Result:=NPERR_INVALID_FUNCTABLE_ERROR; exit;
    end;

    g_pNavigatorFuncs := pFuncs; {* save it for future reference *}

    {* if the plugin's major ver level is lower than the Navigator's,
       then they are incompatible, and should return an error *}
    if HI(pFuncs^.version) > NP_VERSION_MAJOR then begin
        Result:=NPERR_INCOMPATIBLE_VERSION_ERROR; exit;
    end;

    {* if the Navigator's function table is smaller than the plugin expects,
       then they are incompatible, and should return an error *}
    if pFuncs^.size < sizeof (TNPNetscapeFuncs) then begin
        Result:=NPERR_INVALID_FUNCTABLE_ERROR; exit;
    end;

    Result:=NPP_Initialize;
end;

{* called immediately before the plugin DLL is unloaded
*}
function NP_Shutdown:TNPError;
begin
 NPP_Shutdown;
 g_pNavigatorFuncs:=nil;
 Result:=NPERR_NO_ERROR;
end;

{* returns the major/minor version numbers of the Plugin API for the plugin
   and the Navigator
*}
procedure NPN_Version(var plugin_major, plugin_minor,
                          netscape_major, netscape_minor: integer);
begin
    plugin_major   := NP_VERSION_MAJOR;
    plugin_minor   := NP_VERSION_MINOR;
    netscape_major := HI(g_pNavigatorFuncs^.version);
    netscape_minor := LO(g_pNavigatorFuncs^.version);
end;

{* causes the specified URL to be fetched and streamed in
*}
function NPN_GetURL(instance:PNPP; const url,window:PChar):TNPError;
begin
 if g_pNavigatorFuncs<>nil then
  Result:=g_pNavigatorFuncs^.geturl(instance,url,window)
 else
  Result:=NPERR_GENERIC_ERROR;
end;

function NPN_PostURL(instance:PNPP; const url,window:PChar; len:uint32;
                      const buf:PChar; AsFile:TNPBool):TNPError;
begin
 if g_pNavigatorFuncs<>nil then
  Result:=g_pNavigatorFuncs^.posturl(instance, url, window, len, buf, AsFile)
 else
  Result:=NPERR_GENERIC_ERROR;
end;

{* Requests that a number of bytes be provided on a stream.  Typically
   this would be used if a stream was in "pull" mode.  An optional
   position can be provided for streams which are seekable.
*}
function NPN_RequestRead(stream:PNPStream; rangeList:PNPByteRange):TNPError;
begin
 if g_pNavigatorFuncs<>nil then
  Result:=g_pNavigatorFuncs^.requestread(stream,rangeList)
 else
  Result:=NPERR_GENERIC_ERROR;
end;

{* Creates a new stream of data from the plug-in to be interpreted
   by Netscape in the current window.
*}
function NPN_NewStream(instance:PNPP; mtype:TNPMIMEType; stream:PNPStream)
                      :TNPError;
begin
 if g_pNavigatorFuncs<>nil then
  Result:=g_pNavigatorFuncs^.newstream(instance, mtype, stream)
 else
  Result:=NPERR_GENERIC_ERROR;
end;

{* Provides len bytes of data.
*}
function NPN_Write(instance:PNPP; stream:PNPStream;
                   len:int32; var buffer):int32;
begin
 if g_pNavigatorFuncs<>nil then
  Result:=g_pNavigatorFuncs^.write(instance, stream, len, buffer)
 else
  Result:=0;
end;

{* Closes a stream object.
reason indicates why the stream was closed.
*}
function NPN_DestroyStream(instance:PNPP; stream:PNPStream; reason:TNPError)
                          :TNPError;
begin
 if g_pNavigatorFuncs<>nil then
  Result:=g_pNavigatorFuncs^.destroystream(instance, stream, reason)
 else
  Result:=NPERR_GENERIC_ERROR;
end;

{* Provides a text status message in the Netscape client user interface
*}
procedure NPN_Status(instance:PNPP; const Msg:PChar);
begin
 if g_pNavigatorFuncs<>nil then
 g_pNavigatorFuncs^.status(instance, Msg);
end;

{* returns the user agent string of Navigator, which contains version info
*}
function NPN_UserAgent(instance:PNPP):PChar;
begin
 if g_pNavigatorFuncs<>nil then
  Result:=g_pNavigatorFuncs^.uagent(instance)
 else
  Result:='';
end;

{* allocates memory from the Navigator's memory space.  Necessary so that
   saved instance data may be freed by Navigator when exiting.
*}
function NPN_MemAlloc(size:uint32):pointer;
begin
 if g_pNavigatorFuncs<>nil then
  Result:=g_pNavigatorFuncs^.memalloc(size)
 else
  Result:=nil;
end;

{* reciprocal of MemAlloc() above
*}
procedure NPN_MemFree(ptr:Pointer);
begin
 if g_pNavigatorFuncs<>nil then
 g_pNavigatorFuncs^.memfree(ptr);
end;

{* private function to Netscape.  do not use!
*}
procedure NPN_ReloadPlugins(reloadPages:TNPBool);
begin
 if g_pNavigatorFuncs<>nil then
 g_pNavigatorFuncs^.reloadplugins(reloadPages);
end;

{$ifdef demo}
function DemoInfo:integer;
const S='Plug-in npdemo.dll is running.'#13#10#13#10+
        'It has been created by means of unregistered version of plugin development '+
        'tool for Delphi compiler written by Andrei Kashin'+
        '(E-mail: Andrei.Kashin@Fysik.uu.se).'#13#10#13#10+
        'Thank you for using of the tool. Send me E-mail to register and get '+
        'full featured version.'#13#10#13#10+
        'If you have got this DLL by other way it may be dangerous.'+
        'I didn''t allow users of unregistered version to distribute these DLLs. '+
        'Press <Cancel> button to avoid loading plug-in DLL.';
      T='Netscape plug-in demo.  Copyright 1997 Andrei N. Kashin';
begin
 Result:=MessageBox(0,S,T,mb_OkCancel or mb_IconStop);
end;
{$endif}

function NPP_InitializeDef:TNPError;
begin
{$ifdef demo}
 if DemoInfo=IDCancel then Result:=NPERR_MODULE_LOAD_FAILED_ERROR
 else Result:=NPERR_NO_ERROR;
{$else}
 Result:= NPERR_NO_ERROR;
{$endif}
end;

procedure NPP_ShutdownDef;
begin
end;

type

TStreamData = record
 S:TNetscapeStream;
end;


procedure FillParamBuf(var PlugInstance:TPluginInstance;
                       Count:int16; argn,argv:PArrayPChar);
var i:integer;
    BufSz:integer;
    P:PChar;
begin
 with PlugInstance do begin
  ParamCnt:=Count;
  ParamBuf:=nil;
  if Count<=0 then exit;
  BufSz:=0;
  for i:=0 to Pred(Count) do begin
   inc(BufSz,StrLen(argn^[i])+1);
   inc(BufSz,StrLen(argv^[i])+1);
  end;
  P:=NPN_MemAlloc(BufSz);
  if P=nil then exit;
  ParamBuf:=P;
  for i:=0 to Pred(Count) do begin
   StrCopy(P,argn^[i]); inc(P,StrLen(argn^[i])+1);
   StrCopy(P,argv^[i]); inc(P,StrLen(argv^[i])+1);
  end;
 end;
end;

function NPP_NewDef(pluginType:TNPMIMEType; instance:PNPP;
                    mode:uint16; argc:int16; argn,argv:PArrayPChar;
                    saved:PNPSavedData):TNPError; cdecl;
var This:PPluginInstance;
begin
  if instance = nil then begin
     Result:=NPERR_INVALID_INSTANCE_ERROR; exit;
  end;
  if Not ThreadSafe then
  if ThreadID<>GetCurrentThreadID then begin
    Result:=NPERR_GENERIC_ERROR;
    exit;
  end;
  instance^.pdata:= NPN_MemAlloc(sizeof(TPluginInstance));
  This := PPluginInstance(instance^.pdata);
  if This <> nil then begin
   This^.fWindow := nil;
   This^.window:=0;
   This^.MControl:=nil;
   This^.ParamBuf:=nil;
   This^.fMode := mode;

       // Mode is NP_EMBED, NP_FULL, or NP_BACKGROUND (see npapi.h)
        // *Developers*: Initialize fields of your plugin
        // instance data here.  If the NPSavedData is non-
        // NULL, you can use that data (returned by you from
        // NPP_Destroy to set up the new plugin instance.
        //
    FillParamBuf(This^,argc,argn,argv);
    Result:=NPERR_NO_ERROR;
    exit;
   end
    else Result:=NPERR_OUT_OF_MEMORY_ERROR;
end;

function NPN_GetArgValue(Instance:PNPP; ArgName:PChar):PChar;
var i:integer;
    P:PChar;
begin
 with TPluginInstance(Instance^.pdata^) do begin
  Result:='';
  if ParamBuf=nil then exit;
  P:=ParamBuf;
  for i:=0 to Pred(ParamCnt) do begin
    if StrIComp(P,ArgName)=0 then begin
     inc(P,StrLen(P)+1);
     Result:=P;
     exit;
    end;
     inc(P,StrLen(P)+1);
     inc(P,StrLen(P)+1);
  end;
 end;
end;

procedure KillWnd(P:PPluginInstance);
begin
 if P^.window<>0 then begin
  try
   P^.MControl.Free;
  except
   MessageBox(0,'Exception in TForm.Free','Exception',mb_Ok);
  end;
  P^.MControl:=nil;
  SetWindowLong(P^.window,GWL_WndProc,integer(P^.lpfnOld));
  P^.window:=0;
 end;
end;

function NPP_DestroyDef(instance:PNPP; var save:PNPSavedData):TNPError;cdecl;
begin
 if instance = nil then begin
   Result:=NPERR_INVALID_INSTANCE_ERROR; exit;
 end;
    //
    // *Developers*: If desired, call NP_MemAlloc to create a
    // NPSavedDate structure containing any state information
    // that you want restored if this plugin instance is later
    // recreated.
    //
 if instance^.pdata<>nil then begin
    KillWnd(PPluginInstance(instance^.pdata));
    if PPluginInstance(instance^.pdata)^.ParamBuf<>nil then
    NPN_MemFree(PPluginInstance(instance^.pdata)^.ParamBuf);
    NPN_MemFree(instance^.pdata);
    instance^.pdata:=nil;
 end;
 Result:=NPERR_NO_ERROR;
end;

function PlugInWndProc(Wnd:HWnd; Msg,wParam:word; lParam:integer):integer;
stdcall;export;
var H:HWnd;
begin
 case Msg of
 WM_Size: begin
    H:=GetTopWindow(Wnd);
    if H<>0 then MoveWindow(H,0,0,LoWord(LParam),HiWord(LParam),false);
  end;
 WM_ERASEBKGND: begin
   H:=GetTopWindow(Wnd);
   Result:=0;
   if H<>0 then exit;
 end;
 end;
 Result:=DefWindowProc(Wnd,Msg,wParam,lParam);
end;

function NPP_SetWindowDef(instance:PNPP; np_window:PNPWindow):TNPError;cdecl;
var W:HWND;
    R:TRect;
    This:PPluginInstance;
begin
  if instance = nil then begin
   Result:=NPERR_INVALID_INSTANCE_ERROR; exit;
  end;

  This := PPluginInstance(instance^.pdata);
    //
    // *Developers*: Before setting fWindow to point to the
    // new window, you may wish to compare the new window
    // info to the previous window (if any) to note window
    // size changes, etc.
    //

  if (np_window = nil) or (This=nil) then begin
    Result:=NPERR_GENERIC_ERROR; exit;
  end;


  if (np_window^.window=nil) and (This^.window<>0) then
  begin   // window went away
        KillWnd(This); //unubclass here
        This^.window:=0;
        Result:=NPERR_NO_ERROR;
        exit;
  end;
  if (This^.window=0) and (np_window^.window<>nil) then
   begin   // First time in -- no window created by plugin yet
      W:=HWND(np_window^.window);
      This^.window:=W;
      This^.fwindow:=np_window;
      // Make subclass here
      This^.lpfnOld:=pointer(SetWindowLong(W,GWL_WndProc,integer(@PluginWndProc)));
      if PlugInFormClass<>nil then begin
        This^.MControl:=PlugInFormClass.NPCreate(instance,W);
      end;
  end;
    // resize or moved window (or newly created)
  W:=HWND(np_window^.window);
  if W<>0 then begin
   if This^.MControl<>nil then begin
    GetWindowRect(W,R);
    This^.MControl.SetBounds(0,0,R.Right-R.Left,R.Bottom-R.Top);
   end;
   InvalidateRect(W,nil,false);
   UpdateWindow(W);
  end;
  Result:=NPERR_NO_ERROR;
end;

function NPP_NewStreamDef(instance:PNPP; mtype:TNPMIMEType; stream:PNPStream;
                          seekable:TNPBool; var stype:uint16):TNPError; cdecl;
begin
 if instance = nil then begin
  Result:=NPERR_INVALID_INSTANCE_ERROR; exit;
 end;
 stream^.pdata:=nil;
 stype:=NP_ASFILE;
 if TPluginInstance(instance^.pdata^).MControl<>nil then begin
  SendMessage(TPluginInstance(instance^.pdata^).MControl.Handle,
    NM_NewStream,0,integer(stream));
  if stream^.pdata<>nil then begin
   if TStreamData(stream^.pdata).S.FType = stNormal then stype:=NP_Normal
   else stype:=NP_ASFILE;
  end;
 end;
 Result:= NPERR_NO_ERROR;
end;

//
// *Developers*:
// These next 2 functions are directly relevant in a plug-in which handles the
// data in a streaming manner.  If you want zero bytes because no buffer space
// is YET available, return 0.  As long as the stream has not been written
// to the plugin, Navigator will continue trying to send bytes.  If the plugin
// doesn't want them, just return some large number from NPP_WriteReady(), and
// ignore them in NPP_Write().  For a NP_ASFILE stream, they are still called
// but can safely be ignored using this strategy.
//

const STREAMBUFSIZE = $FFFFFFF; // If we are reading from a file in NPAsFile
                                  // mode so we can take any size stream in our
                                  // write call (since we ignore it)

function NPP_WriteReadyDef(instance:PNPP; stream:PNPStream):int32; cdecl;
begin
 Result:= STREAMBUFSIZE;   // Number of bytes ready to accept in NPP_Write()
end;


function NPP_WriteDef(instance:PNPP; stream:PNPStream; offset,len:int32;
                    var buffer):int32; cdecl;
begin
 if stream^.pdata<>nil then
   TStreamData(stream^.pdata).S.ReadHandler(buffer,len)
 else
  if TPluginInstance(instance^.pdata^).MControl<>nil then begin
   SendMessage(TPluginInstance(instance^.pdata^).MControl.Handle,
     NM_NewStream,0,integer(stream));
   if stream^.pdata<>nil then
    TStreamData(stream^.pdata).S.ReadHandler(buffer,len);
  end;
 Result:=len;             // The number of bytes accepted
end;


function NPP_DestroyStreamDef(instance:PNPP; stream:PNPStream;
                              reason:TNPError):TNPError; cdecl;
begin
  if instance = nil then begin
   Result:=NPERR_INVALID_INSTANCE_ERROR; exit;
  end;
  Result:=NPERR_NO_ERROR;
  if stream^.pdata<>nil then
   TStreamData(stream^.pdata).S.DestroyHandler(Reason);
end;

procedure NPP_StreamAsFileDef(instance:PNPP; stream:PNPStream;
                              const fname:PChar); cdecl;
begin
 if instance <> nil then begin
  if stream^.pdata<>nil then
  TStreamData(stream^.pdata).S.AsFileHandler(fname);
 end;
end;

procedure NPP_PrintDef(instance:PNPP; printInfo:PNPPrint); cdecl;
begin
    if printInfo = nil then exit;   // trap invalid parm
    if instance <> nil then begin
        if printInfo^.mode = NP_FULL then begin
            //
            // *Developers*: If your plugin would like to take over
            // printing completely when it is in full-screen mode,
            // set printInfo->pluginPrinted to TRUE and print your
            // plugin as you see fit.  If your plugin wants Netscape
            // to handle printing in this case, set printInfo->pluginPrinted
            // to FALSE (the default) and do nothing.  If you do want
            // to handle printing yourself, printOne is true if the
            // print button (as opposed to the print menu) was clicked.
            // On the Macintosh, platformPrint is a THPrint; on Windows,
            // platformPrint is a structure (defined in npapi.h) containing
            // the printer name, port, etc.
            //
            {void* platformPrint = printInfo->print.fullPrint.platformPrint;
            NPBool printOne = printInfo->print.fullPrint.printOne;}

            printInfo^.fullPrint.pluginPrinted := FALSE; // Do the default

        end
        else begin    // If not fullscreen, we must be embedded
            //
            // *Developers*: If your plugin is embedded, or is full-screen
            // but you returned false in pluginPrinted above, NPP_Print
            // will be called with mode == NP_EMBED.  The NPWindow
            // in the printInfo gives the location and dimensions of
            // the embedded plugin on the printed page.  On the Macintosh,
            // platformPrint is the printer port; on Windows, platformPrint
            // is the handle to the printing device context.
            //
           { NPWindow* printWindow = &(printInfo->print.embedPrint.window);
            void* platformPrint = printInfo->print.embedPrint.platformPrint;}

        end;
    end;
end;


{  fills in the func table used by Navigator to call entry points in
   plugin DLL.  Note that these entry points ensure that DS is loaded
   by using the NP_LOADDS macro, when compiling for Win16}
function NP_GetEntryPoints(pFuncs:PNPPluginFuncs):TNPError;
begin
    { trap a NULL ptr }
    if pFuncs = nil then begin
     Result:=NPERR_INVALID_FUNCTABLE_ERROR; exit;
    end;
    {* if the plugin's function table is smaller than the plugin expects,
       then they are incompatible, and should return an error *}
    if pFuncs^.size < sizeof(TNPPluginFuncs) then begin
      Result:=NPERR_INVALID_FUNCTABLE_ERROR; exit;
    end;
    pFuncs^.version := (NP_VERSION_MAJOR shl 8) or NP_VERSION_MINOR;
    { filling pFuncs^ by defined functions}

    pFuncs^.newp          := NPP_NewDef;
    pFuncs^.destroy       := NPP_DestroyDef;
    pFuncs^.setwindow     := NPP_SetWindowDef;
    pFuncs^.newstream     := NPP_NewStreamDef;
    pFuncs^.destroystream := NPP_DestroyStreamDef;
    pFuncs^.asfile        := NPP_StreamAsFileDef;
    pFuncs^.writeready    := NPP_WriteReadyDef;
    pFuncs^.write         := NPP_WriteDef;
    pFuncs^.print         := NPP_PrintDef;
    pFuncs^.event         := nil;       {* reserved *}
    Result:=NPERR_NO_ERROR;
end;


end.

